# Agora RTSA-Lite SDK 介绍(RTM)

*简体中文| [English](README.RTM.en.md)*

声网实时码流加速（Real-time Streaming Acceleration, RTSA）SDK Lite 版，依托声网自建的底层实时传输网络 Agora SD-RTN™ (Software Defined Real-time Network)，为所有支持网络功能的 Linux/RTOS 设备提供音视频码流在互联网实时传输的能力。与此同时，SDK Lite整合了Agora 实时消息（Real-time Messaging，RTM）SDK 部分功能，提供了稳定可靠、低延时、高并发的全球消息云服务，帮助你快速构建实时场景。

# 运行示例项目

声网提供了一个简单的示例项目，帮助开发者轻松掌握我们的API(RTM)使用，从而更高效的集成到自己的应用程序中。该示例项目 hello_rtm.c 位于 example/hello_rtm/ 目录，编译后可以演示实时消息收发的功能。

## 环境准备

- 一台装有 Ubuntu 16.04 或 18.04 的 PC，可以是虚拟机。用于编译和运行示例代码进行实时消息互通。

## 操作步骤

### 1. 创建 Agora 账号并获取 App ID

请参考[README.md](./README.md) 操作步骤1

### 2. 获取 Agora RESTful API 需要的客户 ID 和客户密钥

请参考[README.md](./README.md) 操作步骤2

### 3. 获取免费的体验 **License**

请参考[README.md](./README.md) 操作步骤3

### 4. 编译 license_query、license_activator 和 hello_rtm

通过以下命令编译 license_query、license_activator 和 hello_rtm。
*注意：如果需要在设备端（通常是ARM Linux系统）运行 hello_rtm ，请先参考 [交叉编译指南](./cross_compile.zh.md)*
```
$ cd example
$ ./build-x86_84.sh
```
编译完成后，会在当前目录里创建out/x86_64/目录，并在该目录下生成 license_query、license_activator 和 hello_rtm 可执行文件。


### 5. <span id="jump">激活 License</span>
在运行 hello_rtm 之前，你需要先激活 License。

请参考 [License集成指南](./docs/LICENSE_GUIDE.md)

### 6. 运行 hello_rtm

#### 参数

* **-h, --help ：** 打印帮助信息。
* **-i, --appId ：** 用于指定用户的appId。无默认值，必填。
* **-t, --token ：** 用于指定用户的token。默认值为空字符串。*注意：RTM的token与推拉流所用的token不同*
* **-r, --credentialFile ：** 用于指定设备标识文件。参数为文件路径，默认值为 **./deviceID.bin**。
* **-C, --certificateFile ：** 用于指定证书文件。参数为文件路径，默认值为 **./certificate.bin**。
* **-l, --sdkLogDir ：** 用于指定存放SDK Log的位置。 参数为目录，默认值为当前目录。
* **-p, --peerUid ：** 用于指定接收消息端用户ID。默认值为 **peer**。
* **-R, --rtmUid ：** 用于指定发送消息端用户ID。 默认值为 **user**。
* **-o, --role ：** 用于指定运行模式，演示时选择3即可。默认值为3。

#### 示例

可以打开两个终端，分别在两个终端输入如下命令行，通过从终端输入消息，实现两个终端之间互发消息。
```
$ cd out/x86_64
$ ./hello_rtm --appId YOUR_APPID --rtmUid user1 --peerUid user2
$ ./hello_rtm --appId YOUR_APPID --rtmUid user2 --peerUid user1
```

请注意：
- 参数 `YOUR_APPID` 需要替换为你创建的 App ID。
- 确保当前目录包含证书 **deviceID.bin** 和 **certificate.bin**（请参考 [License集成指南](./docs/LICENSE_GUIDE.md)）。
- 消息只能发送给指定用户(peerUid)



# 联系我们

- 如果发现了示例代码的 bug，欢迎提交 [issue](https://github.com/AgoraIO/Basic-RTSA/issues)

